#!/bin/bash

#
#digitec-suitecrm-web Copyright (c) by DIGITEC GmbH 2017
#

for instance in $(/usr/sbin/ucr search --key suitecrm/instance |grep name |cut -d/ -f3 |sort -u); do
    SUITECRM_PATH=$(/usr/sbin/ucr get suitecrm/instance/$instance/path)
    if [ -z "$SUITECRM_PATH" ]; then
        SUITECRM_PATH=/var/www/$instance
    fi

    if [ -f $SUITECRM_PATH/do-cron.touch ]; then
        cd $SUITECRM_PATH
        /usr/bin/php -c /etc/php/7.0/apache2/php.ini -f cron.php
    fi
done
