import listener,httplib,urllib
import sys
from md5 import md5
import univention.debug
import sys
sys.path.append("/usr/share/suitecrm/")
import jsonoptimizepatch
import os

json=jsonoptimizepatch
host="localhost"
path="/"+suitecrm_url+"/service/v4/rest.php"
pwdFileName="/etc/suitecrm/"+suitecrm_instance+"/ucsadmin.secret"
usernameFileName="/etc/suitecrm/ucsadmin.username"
username="ucsadmin"
if (os.path.isfile(pwdFileName)):
    listener.setuid(0)
    pwdFILE=open(pwdFileName,"r")
    password=pwdFILE.readline()
    pwdFILE.close()
    listener.unsetuid()
    password=password.rstrip()
else:
    password="secret"
if (os.path.isfile(usernameFileName)):
    listener.setuid(0)
    usrFILE=open(usernameFileName,"r")
    username=usrFILE.readline()
    usrFILE.close()
    listener.unsetuid()
    username=username.rstrip()

lockfile=suitecrm_path+"/do-cron.touch"
cookie="a"
conn="a"
sys.setrecursionlimit(1500)
suitecrm2ldap={
# IN UCS OBERFLAECHE        
        'employee_status':'SuiteCRMEmployeeStatus',
        'last_name':'sn',
        'phone_fax':'facsimileTelephoneNumber',
        'address_street':'street',
        'email1':'mailPrimaryAddress',
        'first_name':'givenName',#Leave of Absence ,
        'title':'title',
#        'department':'departmentNumber',
        'suitecrm_login':'uid',
        'user_name':'uid',
#        'deleted':'',
        'address_city':'l',
        'phone_work':'telephoneNumber',
        'address_postalcode':'postalCode',
        'phone_mobile':'mobile',
        'phone_home':'homePhone',
        }

# mailAlternativeAddress



def restCall(method,jsonin):
    """do a SuiteCRM call"""
    univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO, "Call %s / %s " % (method,jsonin))
    #    ja=json.read(jsonin)
    params= urllib.urlencode({'method':method,
                              'input_type':"JSON",
                              'response_type':"JSON",
                              'rest_data':jsonin})
    headers = {"Content-type": "application/x-www-form-urlencoded",   "Accept": "text/plain"}
    global cookie
    global conn
    if (cookie != ""):
	univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO,"Cookie=%s " % cookie) 
    conn.request("POST", path, params, headers)
    response = conn.getresponse()
    univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO,"Response %s / %s " % (response.status, response.reason)) 
    c=response.getheader("set-cookie")
    if (not (c is None)) :
       cookie=c
    data = response.read()
    univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO,"Data='%s' (%s) " % (data, sys.getdefaultencoding()) )

    outr=json.read(data)
    return outr


def createRoleIfNotThere(session,rolename):
    univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO, "createRoleIfNotThere role=%s" % rolename)
    roles=restCall("get_entry_list", '{"session":"'+session+'","module_name":"ACLRoles","query":"name=\''+rolename+'\'"}')
    found=roles.get("result_count",0)
    if (found==1):
       return roles['entry_list'][0]['id']
    if (found==0):
        result=restCall("set_entry", '{"session":"'+session+'","module_name":"ACLRoles","name_value_list":{"name":"'+rolename+'","description":"automaticly created by UCS Directory Manager entry"},"link_name_to_fields_array":[]}');
        return result['id']

def addRoleNameToUserId(session,userid,rolename):
    roleid=createRoleIfNotThere(session,rolename)
    addRoleIdToUser(session,userid,roleid)

def addRoleIdToUser(session,userid,roleid):
    univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO, "addRoleIdToUser user=%s role=%s" % (userid,roleid))
    user=restCall("set_relationship", '{"session":"'+session+'","module_name":"ACLRoles","module_id":"'+roleid+
                  '","link_field_name":"users","related_ids":["'+userid+'"]}')

def removeRoleIdFromUser(session,userid,roleid):
    univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO, "removeRoleIdFromUser user=%s role=%s" % (userid,roleid))
    user=restCall("set_relationship", '{"session":"'+session+'","module_name":"ACLRoles","module_id":"'+roleid+
                  '","link_field_name":"users","related_ids":["'+userid+'"],"name_value_list":[],"delete":"1"}')


def login(username,password):
    #univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO, "login user=%s password=%s" % (username,password))
    m=md5()
    m.update(password)
    password_md5=m.hexdigest()
    outobj=restCall("login",'{"user_auth":{ "user_name" :"'+ username+'",'+
               '"password":"'+password_md5+'"}}');
    if ("id" in outobj):
        session=outobj["id"]
        return session;
    return -1


def handler(dn, new, old):
  """ Funktion um User in SuiteCRM anzulegen """
  global conn
  global cookie
  univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO, "Start %s" % dn)
  if (not os.path.isfile(lockfile)):
      univention.debug.debug(univention.debug.LISTENER,univention.debug.ERROR, "No SUITECRM logfile %s %s" % (lockfile,dn))
      return -1
  conn = httplib.HTTPConnection(host)
  # Login to SuiteCRM to change something
  session=login(username,password);
  if (session!=-1):
    is_active=0
    if old and not new:
      # user is deleted
      userID=old['uid'][0]
      is_active=0
      is_admin=0
    else:
      userID=new['uid'][0]
      is_active=(new.get('SuiteCRMActive',['FALSE'])[0]=='OK')
      if (is_active):
        is_admin=(new.get('SuiteCRMIsAdmin',['FALSE'])[0]=='OK')
      else:
        is_admin=0

    # Welche Faelle gibt es
    # User wird in der LDAP neu angelegt
    # -> Nach sehen ob der User in SuiteCRM schon existiert, wenn ja weiternutzen, wenn nein neu anlegen
    # User wird modifiziert
    # -> Nach sehen ob der User in SuiteCRM schon existiert, wenn nein, neu anlegen.
    # -> nur die geaenderten Attribute werden neu gesetzt.
    # User wird aus der LDAP geloescht
    # -> in SuiteCRM wird der status auf Inactive gesetzt.
    # -> in SuiteCRM wird der empolyee_status auf Leave of Absence gesetzt.

    newval={}
    oldrole={}
    # Alten Eintrag abrufen
    oldSugarUser=restCall("get_entry_list", '{"session":"'+session+'","module_name":"Users","query":"users.user_name=\''+userID+'\'","order_by":"last_name","offset":0,"select_fields":null,"link_name_to_fields_array":[{"name":"aclroles","value":["id","name"]}]}');
    #link_name_to_fields_array
    create=0
    if (oldSugarUser['result_count']==1):
       entry=oldSugarUser["entry_list"][0]
       univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO, "Newval-list START")
       for nameval in entry["name_value_list"]:
          if (nameval!="date_modified"):
            univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO, "Newval-item %s" % nameval)
            #newval[nameval]=entry["name_value_list"][nameval]["value"]
          if (nameval=="id"):
            newval[nameval]=entry["name_value_list"][nameval]["value"]
            create=1

       if (len(oldSugarUser["relationship_list"][0]["link_list"])>0):
           for linkVal in oldSugarUser["relationship_list"][0]["link_list"][0]["records"]:    
               oldrole[linkVal["link_value"]["name"]["value"]]=linkVal["link_value"]["id"]["value"]


    for suitecrmkey in suitecrm2ldap:
        ldapkey=suitecrm2ldap[suitecrmkey]
        if (ldapkey in new):
           newval[suitecrmkey]=new[ldapkey][0]

    newval["external_auth_only"]=1

    if (is_active):
	newval["status"]="Active";
        newval["deleted"]=0;
        create=1
    else:
       	newval["status"]="Inactive";
        
    newval["is_admin"]=is_admin;


    # Einen Neuen Admin einrichten; einen alten mit neuen Werten beschreiben...
    if (create):
      user=restCall("set_entry", '{"session":"'+session+'","module_name":"Users","name_value_list":'+json.write(newval)+
	',"link_name_to_fields_array":[]}');
      suitecrm_user_id=user['id']
      # Rollen bearbeiten
      if new: 
         for rolename in new.get("SuiteCRMRoles",[]):
           univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO,"LDAPRole: %s" % rolename)
           if rolename not in oldrole :
             addRoleNameToUserId(session,suitecrm_user_id,rolename)
         for rolename in oldrole:
           univention.debug.debug(univention.debug.LISTENER,univention.debug.INFO,"SugarRole: %s" % rolename)
           if rolename not in new.get("SuiteCRMRoles",[]):
             roleid=oldrole[rolename]
             removeRoleIdFromUser(session,suitecrm_user_id,roleid)
      else:
         for rolename in oldrole:
            roleid=oldrole[rolename]
            removeRoleIdFromUser(session,suitecrm_user_id,roleid)


def initialize():
  """ Initialisierungsfunktion Alle Benutzer ausser dem UCS-Admin werden auf status=Inactive gesetzt """
  # Login to SuiteCRM to change something
  global conn
  global cookie
  conn = httplib.HTTPConnection(host)
  if (not os.path.isfile(lockfile)):
      return -1
  session=login(username,password);
  if (session!=-1):
    oldSugarUser=restCall("get_entry_list", '{"session":"'+session+'","module_name":"Users","query":""}');
    for entry in oldSugarUser["entry_list"]:
       newval={}
       for nameval in entry["name_value_list"]:
          newval[nameval]=entry["name_value_list"][nameval]["value"]
       if (newval["user_name"] != username):
          newval["status"]="Inactive";
          newval["is_admin"]=0;
          resetEntry=restCall("set_entry", '{"session":"'+session+'","module_name":"Users","name_value_list":'+json.write(newval)+
	      ',"link_name_to_fields_array":[]}');
