<?php

function getBytes($val) {
    $val = trim($val);
    $last = strtolower($val{strlen($val)-1});
    switch($last) {
        // The 'G' modifier is available since PHP 5.1.0
        case 'g':
            $val *= 1024;
        case 'm':
            $val *= 1024;
        case 'k':
            $val *= 1024;
    }
    return $val;
}
function check_ini($ini,$value) {
 $val=ini_get($ini);
 if (getBytes($val)<getBytes($value)) {
  print "$ini shall be set to at least $value (now: $val)\n";
 }
}

if(ini_get('date.timezone') == '') {
  print 'date.timezone not set!  date.timezone shall be set to "Europe/Berlin" in php.ini'+"\n";
}


check_ini("memory_limit","40m");
check_ini("post_max_size","22m");
check_ini("upload_max_filesize","20m");

?>
